program ex3
use mpi
implicit none

integer rank, np, ierr, number
integer i, status(MPI_STATUS_SIZE)

call MPI_INIT(ierr)

call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

if (np < 2) then
    call MPI_ABORT(MPI_COMM_WORLD, 99, ierr)
endif

if (rank == 0) then
    print *, "Type an integer from the input"
    read *, number
    do i=1, np-1
      call MPI_SEND(number, 1, MPI_INTEGER, i, 0, MPI_COMM_WORLD, ierr)
    enddo
else
    call MPI_RECV(number, 1, MPI_INTEGER, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr)
    print "(3(A,I6))","Process ", rank, " received ", number, " from process ", status(MPI_SOURCE) 
endif
call MPI_FINALIZE(ierr)
end program ex3
