#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int np, rank;
    int name_len;

    //char proc_name[20];
    char proc_name[MPI_MAX_PROCESSOR_NAME];
    MPI_Init(&argc, &argv);
    MPI_Get_processor_name(proc_name, &name_len);

    MPI_Comm_size(MPI_COMM_WORLD, &np);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    printf("\"Hello, world\" from process %d on node %s, total %d processes\n", rank, proc_name, np);
    MPI_Finalize();
}
