program hello
use mpi
implicit none
integer ierr, name_len, np, rank;
character (len=MPI_MAX_PROCESSOR_NAME) proc_name

call MPI_INIT(ierr)
call MPI_GET_PROCESSOR_NAME(proc_name, name_len, ierr)
call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

print "(A, I4, 3(A), I4, A)", "'Hello, world!' from process ",rank, " on node ", trim(proc_name), " total ", np, " processes."
call MPI_Finalize(ierr)

end program hello
