#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number, size, rank;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    if (rank == 0){
        printf("Enter an integer number: ");
        scanf("%d", &number);
    }

    // broadcast the result to the other tasks

    printf("My id is %d. I received %d from process 0\n", rank, number);


    MPI_Finalize();
}
