program ex6
use mpi
implicit none

integer rank, np, ierr, num

call MPI_INIT(ierr)

call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

if (np < 2) then
    call MPI_ABORT(MPI_COMM_WORLD, 99, ierr)
endif

if (rank == 0) then
    print *, "Type an integer from the input"
    read *, num
endif

// broadcast the result

print "(3(A,I6))","Process ", rank, " received ", num, " from process 0" 
call MPI_FINALIZE(ierr)
end program ex6
