#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number, size, rank;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    if (size < 2){
        MPI_Abort(MPI_COMM_WORLD, 99);
    }
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    if (rank == 0){
        printf("Type any number from the input: ");
        scanf("%d", &number);
        MPI_Send(&number, 1, MPI_INT, 1, 0, MPI_COMM_WORLD);
    }else if (rank == size-1){
        MPI_Recv(&number, 1, MPI_INT, rank-1, rank-1, MPI_COMM_WORLD, MPI_STATUS_IGNORE); 
    }else{
        MPI_Recv(&number, 1, MPI_INT, rank-1, rank-1, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
        MPI_Send(&number, 1, MPI_INT, rank+1, rank, MPI_COMM_WORLD);
        printf("My id is %d. I received %d\n", rank, number);
    }  


    MPI_Finalize();
}
