#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int num, np, rank;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &np);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    num = rank;

    MPI_Sendrecv(&num, 1, MPI_INT, (rank+1)%np, rank, &num, 1, MPI_INT, (rank-1+np)%np,  MPI_ANY_TAG, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

    printf("My id is %d. I received %d\n", rank, num);

    MPI_Finalize();
}
