#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number, size, rank;
    MPI_Status status;
    int i;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    if (size < 2){
        MPI_Abort(MPI_COMM_WORLD, 99);
    }
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    if (rank == 0){
        printf("Enter number of random points:");
        scanf("%d", &number);
	real x[number];
	real x[number];
        for (i=1; i<size; i++)
            MPI_Send(&number, 1, MPI_INT, i, 0, MPI_COMM_WORLD);
    }else{
        MPI_Recv(&number, 1, MPI_INT, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
        printf("My id is %d. I received %d from process %d\n", rank, number, status.MPI_SOURCE);
    }  


    MPI_Finalize();
}
