#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number, np, rank;

    // define the request handles here
    



    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &np);
    if (np < 2){
        MPI_Abort(MPI_COMM_WORLD, 99);
    }
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    number = rank;

    // Call non-blocking send/receive to do cyclic transfers
    // process i sends number to process (i+1)%np and receives number from process (rank-1+np)%np



    printf("My id is %d. I received %d, sent by process %d\n", rank, number, (rank-1+np)%np);

    MPI_Finalize();
}
