program ex2
use mpi
implicit none

integer rank, np, ierr, num

call MPI_INIT(ierr)

call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

if (rank == 0) then
    print *, "Type an integer from the input"
    read *, num
    call MPI_SEND(num, 1, MPI_INTEGER, 1, 0, MPI_COMM_WORLD, ierr)
else if (rank == np-1) then
    call MPI_RECV(num, 1, MPI_INTEGER, rank-1, rank-1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr)
    print "(2(A,I6))","Process ",rank, " received ", num
else
    call MPI_RECV(num, 1, MPI_INTEGER, rank-1, rank-1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr)
    call MPI_SEND(num, 1, MPI_INTEGER, rank+1, rank, MPI_COMM_WORLD, ierr)
    print "(2(A,I6))","Process ",rank, " received ", num
endif
call MPI_FINALIZE(ierr)
end program ex2
