program ex3
use mpi
implicit none

integer rank, np, ierr, num, requests(2)

call MPI_INIT(ierr)

call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

num = rank

call MPI_IRECV(num, 1, MPI_INTEGER, mod((rank-1+np),np), mod((rank-1+np),np), MPI_COMM_WORLD, requests(1), ierr)
call MPI_ISEND(num, 1, MPI_INTEGER, mod(rank+1,np), rank, MPI_COMM_WORLD, requests(2), ierr)
call MPI_WAITALL(2, requests, MPI_STATUSES_IGNORE, ierr)
print "(3(A,I6))","Process ",rank, " received ", num, " sent by ",mod((rank-1+np),np)
call MPI_FINALIZE(ierr)

end program ex3
