
#!/bin/sh

if [ X${USER} = X ]
then
  USER=`/usr/bin/whoami`
fi
echo $USER


BASE=/general/public/training/mpi/Spring2020
MYP=${SCRATCH}/hprc_shortcourse_mpi

if [ ! -d ${MYP} ];
then
   echo "...creating subdirectory ${MYP}." 
   mkdir ${MYP}
   cp -rf ${BASE}/casestudy ${MYP}
   cp -rf ${BASE}/examples ${MYP}
   cp -rf ${BASE}/exercises ${MYP}
   cp -rf ${BASE}/extra ${MYP}
   echo "...all files have been copied to ${MYP}"
   echo "...done."
else
  echo "...directory ${MYP} has already been setup."
  echo "...if you want to setup again clean directory ${MYP} first"
  echo "...exiting"
fi




